<template>
  <div class="Content">
    <el-breadcrumb separator-class="el-icon-arrow-right">
      <el-breadcrumb-item>新媒体</el-breadcrumb-item>
      <el-breadcrumb-item>应用分析</el-breadcrumb-item>
      <el-breadcrumb-item>直播分析</el-breadcrumb-item>
    </el-breadcrumb>
    <el-card class="box-card">
      <el-form
        ref="form"
        :model="form"
        size="small"
        :inline="true"
        label-width="120px"
        class="demo-form-inline"
      >
        <el-form-item label="日期">
          <el-date-picker
            v-if="form.date.length"
            v-model="form.date"
            type="daterange"
            :disabled-date="time => disabledDate(time)"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
            :clearable="false"
          >
          </el-date-picker>
        </el-form-item>
        <el-form-item label="应用">
          <el-select
            v-model="form.app"
            placeholder="请选择时段"
            @change="change"
          >
            <el-option
              v-for="item in cycle"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              :disabled="item.disabled"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="渠道">
          <el-select
            filterable
            multiple
            collapse-tags
            clearable
            v-model="form.channel"
            @change="changechannel"
            placeholder="请选择渠道"
          >
            <el-option
              v-for="item in channel"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              :disabled="item.disabled"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="版本">
          <el-select
            filterable
            multiple
            collapse-tags
            clearable
            v-model="form.version"
            placeholder="请选择版本"
            @change="changeversion"
          >
            <el-option
              v-for="item in version"
              :key="item.value"
              :label="item.label"
              :value="item.value"
              :disabled="item.disabled"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="直播编号">
          <el-input
            v-model="form.liveId"
            placeholder="请输入直播编号"
            clearable
          />
        </el-form-item>
        <el-form-item label="直播标题">
          <el-input
            v-model="form.liveTitle"
            placeholder="请输入直播标题"
            clearable
          />
        </el-form-item>
        <!-- <el-form-item label="主播">
          <el-input
            v-model="form.publisherName"
            placeholder="请输入主播名称"
            clearable
          />
        </el-form-item> -->
        <el-form-item style="float: right">
          <el-button type="primary" @click="onSubmit">查询</el-button>
        </el-form-item>
      </el-form>
    </el-card>
    <br />
    <el-card class="box-card">
      <div style="text-align: right">
        <el-button
          size="small"
          style="margin-left: 0.5em"
          type="primary"
          @click="onExport"
        >
          导出
        </el-button>
      </div>
      <br />
      <br />
      <el-table
        :data="table.records || []"
        style="width: 100%"
        :header-cell-style="{
          backgroundColor: '#f4f5f7',
          color: '#606266',
        }"
        @sort-change="sort_change"
      >
        <el-table-column
          prop="liveId"
          header-align="center"
          align="center"
          label="直播编号"
          show-overflow-tooltip
        >
          <template #default="scope">
            <span v-text="scope.row.liveId || '-'"></span>
          </template>
        </el-table-column>
        <el-table-column
          prop="liveTitle"
          :width="320"
          header-align="center"
          align="center"
          label="直播标题"
          show-overflow-tooltip
        >
          <template #default="scope">
            <span v-text="scope.row.liveTitle || '-'"></span>
          </template>
        </el-table-column>
        <el-table-column
          show-overflow-tooltip
          label="应用名称"
          header-align="center"
          align="center"
        >
          <template #default>
            <span>{{ lastParams.app || '-' }}</span>
          </template>
        </el-table-column>
        <!-- <el-table-column
          prop="publisherName"
          header-align="center"
          align="center"
          label="主播"
          show-overflow-tooltip
        >
          <template #default="scope">
            <span>{{ scope.row.publisherName || "-" }}</span>
          </template>
        </el-table-column> -->
        <!-- <el-table-column
          label="关注用户数"
          header-align="center"
          align="center"
          prop="follow"
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.follow || 0"
              :endVal="scope.row.follow || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column> -->
        <el-table-column
          label="观看用户数"
          header-align="center"
          align="center"
          prop="userCount"
          sortable
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.userCount || 0"
              :endVal="scope.row.userCount || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column>
        <el-table-column
          label="累计观看时长"
          header-align="center"
          align="center"
          prop="duration"
          sortable
        >
          <template #default="scope">
            {{ timeFormat(scope.row.duration) }}
          </template>
        </el-table-column>
        <el-table-column
          label="累计观看次数"
          header-align="center"
          align="center"
          sortable
          prop="pv"
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.pv || 0"
              :endVal="scope.row.pv || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column>
        <el-table-column
          label="评论数"
          header-align="center"
          align="center"
          prop="comments"
          sortable
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.comments || 0"
              :endVal="scope.row.comments || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column>
        <el-table-column
          label="点赞数"
          header-align="center"
          align="center"
          prop="support"
          sortable
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.support || 0"
              :endVal="scope.row.support || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column>
        <!-- <el-table-column
          label="礼物数"
          header-align="center"
          align="center"
          prop="giftCount"
        >
          <template #default="scope">
            <countTo
              :startVal="scope.row.giftCount || 0"
              :endVal="scope.row.giftCount || 0"
              :duration="100"
            ></countTo>
          </template>
        </el-table-column> -->
      </el-table>
      <br />
      <el-pagination
        layout="prev, pager, next"
        :page-size="form.size"
        :current-page="form.page"
        :total="table.total"
        background
        @current-change="changePage"
      />
    </el-card>
  </div>
</template>
<script>
// @ is an alias to /src
import { getRule, getAppList, getSearchData, getLivePage } from '@/api/index';

import countTo from '@/components/counto/vue-countTo.vue';
import { defaultAppNameFunc } from '@/utils/tool.js';

import config from '@/config/index';
export default {
  name: 'Version',
  data() {
    return {
      lastParams: {},
      table: {},
      numType: 'newUser',
      form: {
        app: '',
        version: [],
        channel: [],
        date: [],
        liveId: '',
        liveTitle: '',
        publisherName: '',
        page: 1,
        size: 20,
      },
      cycle: [],
      showList: [],
      channel: [],
      version: [],
    };
  },
  async mounted() {
    const { source, appV, appC, appli, appVLi, appCLi } =
      await this.getAppListFunc();
    const keys = {
      value: 'mname',
      label: 'mname',
    };
    this.cycle = this.verifyList(appli, source, keys, false);
    this.channel = this.verifyList(appCLi, appC, keys, true);
    this.version = this.verifyList(appVLi, appV, keys, true);
    this.form = {
      //   app: (this.cycle[0] || { value: "" }).value,
      app: defaultAppNameFunc(this.cycle),
      version: [(this.version[0] || { value: '' }).value],
      channel: [(this.channel[0] || { value: '' }).value],
      date: [new Date(Date.now() - 604800000), new Date(Date.now() - 86400000)],
      liveId: '',
      liveTitle: '',
      publisherName: '',
    };
    this.onSubmit();
  },
  computed: {},
  methods: {
    verifyList(list, verify, obj, more) {
      if (!obj) return;
      let li = list || [];
      const out = [];
      more && out.push({ value: -1, label: '不限' });
      for (let i = 0; i < li.length; i++) {
        const v = li[i];
        if (verify.length !== 0 && !verify[v.mcode]) continue;
        out.push({
          value: v[obj.value],
          label: v[obj.label],
        });
      }
      return out;
    },
    selectNumType(type) {
      this.numType = type;
    },
    changePage(e) {
      this.form.page = e;
      this.onSubmit();
    },
    onSubmit() {
      this.lastParams = {
        order: this.form.order,
        sortBy: this.form.sortBy || undefined,
        app: this.form.app,
        start: this.FormData(this.form.date[0]),
        end: this.FormData(this.form.date[1]),
        manufacturer: this.form.channel == -1 ? undefined : this.form.channel,
        version: this.form.version == -1 ? undefined : this.form.version,
        liveId: this.form.liveId,
        liveTitle: this.form.liveTitle,
        publisherName: this.form.publisherName,
        page: this.form.page,
        pageSize: this.form.size,
      };
        console.log(this.lastParams.sortBy, this.lastParams.order)
      getLivePage(this.lastParams).then(r => (this.table = r || {}));
    },
    async getAppListFunc() {
      const { r, li, appVersion, channel } = await this.getAppListOri();
      let source = { length: 0 },
        appli = [];
      let appV = { length: 0 },
        appVLi = [];
      let appC = { length: 0 },
        appCLi = [];
      let prvList =
        (r.output && r.output.data && r.output.data.prvRolectrl) || [];
      for (let i = 0; i < prvList.length; i++) {
        const v = prvList[i];
        if (v.controlid == 'RMT_SOURCE')
          (source[v.detid] = true), (source.length = source.length + 1);
        if (v.controlid == 'APP_VERSION')
          (appV[v.detid] = true), (appV.length = appV.length + 1);
        if (v.controlid == 'CHANNEL')
          (appC[v.detid] = true), (appC.length = appC.length + 1);
      }
      if (li.status === '0') appli = li.output.data || [];
      if (appVersion.length) appVLi = appVersion || [];
      if (channel.length) appCLi = channel || [];
      return {
        source,
        appV,
        appC,
        appli,
        appVLi,
        appCLi,
      };
    },
    async getAppListOri() {
      const roleid = JSON.parse(
        window.parent.localStorage.userinfo || '{}'
      ).roleid;
      const r = await getRule({
        db: 'authplat',
        exportMark: '0',
        menuid: 399,
        roleid,
      });
      //   应用列表

      const li = await getAppList({
        exportMark: '0',
        gcode: 'SOURCE',
        pageid: 1,
        pagesize: 1000,
      });
      const cycle = li.output ? li.output.data || [] : [];
      //   应用版本列表
      const appVersion = await getSearchData({
        gcode: 'APP_VERSION',
        source: defaultAppNameFunc(cycle, 'mname'),
      });
      //   应用渠道列表
      const channel = await getSearchData({
        gcode: 'CHANNEL',
        source: defaultAppNameFunc(cycle, 'mname'),
      });
      return { r, li, appVersion, channel };
    },
    disabledDate(time) {
      const first = new Date('2021-06-21 00:00:00');
      return (
        time.getTime() > Date.now() - 86400000 ||
        time.getTime() < first.getTime()
      );
    },
    FormData(date) {
      const d = new Date(date || Date.now() - 86400000);
      const year = d.getFullYear();
      const month =
        d.getMonth() <= 8 ? '0' + (d.getMonth() + 1) : d.getMonth() + 1;
      const day = d.getDate() <= 9 ? '0' + d.getDate() : d.getDate();
      return [year, month, day].join('-');
    },
    timeFormat(t) {
      const Time = t || 0;
      const mH = Time % 3600;
      let hour = (Time - mH) / 3600;
      let min = (mH - (mH % 60)) / 60;
      let son = Number(mH % 60).toFixed(0);
      hour = hour <= 9 ? '0' + hour : hour;
      min = min <= 9 ? '0' + min : min;
      son = son <= 9 ? '0' + son : son;
      let out = [];
      if (hour * 1 > 0) out.push(hour);
      out.push(...[min, son]);
      return out.join(':');
    },
    change() {
      const roleid = JSON.parse(
        window.parent.localStorage.userinfo || '{}'
      ).roleid;
      const appV = {
        length: 0,
      };
      getRule({
        db: 'authplat',
        exportMark: '0',
        menuid: 399,
        roleid,
      }).then(rule => {
        let prvList =
          (rule.output && rule.output.data && rule.output.data.prvRolectrl) ||
          [];
        for (let i = 0; i < prvList.length; i++) {
          const v = prvList[i];
          if (v.controlid == 'APP_VERSION')
            (appV[v.detid] = true), (appV.length = appV.length + 1);
        }
        getSearchData({
          gcode: 'APP_VERSION',
          source: this.form.app,
        }).then(r => {
          let version = [
            {
              label: '不限',
              value: -1,
            },
          ];
          r.map(v => {
            if ((appV.length && appV[v.mcode]) || appV.length === 0)
              version.push({
                value: v.mname,
                label: v.mname,
              });
          });
          this.version = version;
          this.form = {
            ...this.form,
            version: [-1],
          };
        });
        getSearchData({
          gcode: 'CHANNEL',
          source: this.form.app,
        }).then(r => {
          let channel = [
            {
              label: '不限',
              value: -1,
            },
          ];
          r.map(v => {
            if ((appV.length && appV[v.mcode]) || appV.length === 0)
              channel.push({
                value: v.mname,
                label: v.mname,
              });
          });
          this.channel = channel;
          this.form = {
            ...this.form,
            channel: [-1],
          };
        });
      });
    },
    changeversion(v) {
      if (!v.length) return (this.form.version = [-1]);
      const last = v[v.length - 1];
      if (last == -1) return (this.form.version = [-1]);
      let ver = [];
      for (let i = 0; i < v.length; i++) {
        const element = v[i];
        if (element == -1) continue;
        ver.push(element);
      }
      this.form.version = ver;
    },
    changechannel(v) {
      if (!v.length) return (this.form.channel = [-1]);
      const last = v[v.length - 1];
      if (last == -1) return (this.form.channel = [-1]);
      let ver = [];
      for (let i = 0; i < v.length; i++) {
        const element = v[i];
        if (element == -1) continue;
        ver.push(element);
      }
      this.form.channel = ver;
    },
    onExport() {
      const S = this.form.date[0]
        ? this.FormData(this.form.date[0])
        : undefined;
      const E = this.form.date[1]
        ? this.FormData(this.form.date[1])
        : undefined;
      const app = this.lastParams.app || this.form.app;
      const version =
        this.form.version == -1 ? undefined : this.form.version.join(',');
      const manufacturer =
        this.lastParams.manufacturer || this.form.channel.join(',');
      let url =
        config.base.leverAudience +
        '/cxzx-program/new-media/live/export?start=' +
        S +
        '&end=' +
        E +
        '&app=' +
        app;
      version && (url += '&version=' + version);
      version && (url += '&version=' + version);
      this.lastParams.liveId && (url += '&liveId=' + this.lastParams.liveId);
      this.lastParams.liveTitle &&
        (url += '&liveTitle=' + this.lastParams.liveTitle);
      this.lastParams.publisherName &&
        (url += '&publisherName=' + this.lastParams.publisherName);
      manufacturer &&
        manufacturer !== -1 &&
        (url += '&manufacturer=' + manufacturer);
      window.open(url);
    },
    sort_change(type) {
      this.form.sortBy = type.prop;
      this.form.order = type.order === "ascending" ?  0 : type.order === "descending" ? 1 : undefined;
      this.onSubmit();
    },
  },
  components: {
    countTo,
  },
};
</script>

<style>
.Content {
  margin: 10px 15px;
}
.libTitle {
  color: tomato;
  font-weight: 700;
  font-size: 14px;
}
.btn-next i,
.btn-prev i {
  margin: 0 auto;
}
/* .caret-wrapper .ascending {
  display: none;
} */
</style>
